/* drivers/barcelona/usbmode/usbmodechange.h
Copyright (C) 2007 TomTom BV <http://www.tomtom.com/>
Author: Kees Jongenburger <kees.jongenburger@tomtom.com>

Methods to perform state changes between the different usb modes

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2 as
published by the Free Software Foundation.
*/

/* Time in seconds to assume there is no host present when performing
in device detect mode(Device detect == detect is we need to become device)*/

#define DEVICE_DETECT_TIMEOUT_SECONDS 2

/* Time in seconds to assume there there is no connected (non hub) device
on the bus */
#define HOST_DETECT_TIMEOUT_SECONDS 2

#define HOST_DEVICE_REMOVAL_WATCHER_TIMEOUT_SECONDS 2

/* all methods return 1 upon error */

int initial_to_idle(struct usbmode_data *data);

/* device detect related modes changes */
int idle_to_device_detect(struct usbmode_data *data);
int device_detect_to_idle(struct usbmode_data *data);

/* device related mode changes */
int device_detect_to_device(struct usbmode_data *data);
int device_to_idle(struct usbmode_data *data);

/* host detect related mode changes */
int device_detect_to_host_detect(struct usbmode_data *data);
int host_detect_to_idle(struct usbmode_data *data);

/*cla related mode changes */
int host_detect_to_cla(struct usbmode_data *data);
int host_detect_to_host(struct usbmode_data *data);

int cla_to_idle(struct usbmode_data *data);
int host_to_idle(struct usbmode_data *data);

void helper_suspend_usb(void);
